/*
		    TTTTTTT    OOOOO    7777777
		       T      O     O        7
		       T      O     O       7
		       T      O     O      7
		       T      O     O     7
		       T       OOOOO     7

			     EMULATEUR

			  Par Sylvain HUET
		(sylvain.huet@polytechnique.org)
				  1994-2002
	
	  monitor.c : moniteur de l'emulateur
	  
*/

#include <windows.h>

#include "monitor.h"
#include "emuto7.h"
#include "video.h"
#include "main.h"

char    buf[sizebuf];

int merge(char *name,long k)
{
	int     c;
	FILE    *fl;

	fl=fopen(name,"rb");
	if (fl==NULL) return -1;
	while((c=fgetc(fl))!=EOF) buf[k++]=c;
	fclose(fl);
	return 0;
}

int reset()
{
#ifdef TO770
	setreg("pc",0xf98d);
#else
	setreg("pc",0xef26);
#endif
	return 0;
}


int importrom()
{
	int i;
	
	for(i=0xe000;i<0xe7c0;i++) buf[i]=0x39;
	for(i=0xe7c0;i<0xe800;i++) buf[i]=0;
//	for(i=0xe7cc;i<0xe7d0;i++) buf[i]=-1;
	buf[0xe7c3]=-127;
	
#ifdef TO770
	merge("romto770",0xe800);
	buf[0xfbd3]=0x02; buf[0xfbd4]=0x39;
	buf[0xf07c]=0x02; buf[0xf07d]=0x39;
#else
	merge("romto7",0xe800);
	buf[0xfd3e]=0x02; buf[0xfd3f]=0x39;
	buf[0xfc0f]=0x02; buf[0xfc10]=0x39;
#endif
	
	merge("memo7\\basic.m7",0);
	
	return 0;
}

int emustate=0;
int emutimer=0;
int mytickcount=0;
int maxspeed=0;

int isemurunning()
{
	return emustate;
}

int launchemu()
{
	mytickcount=GetTickCount();
	emustate=1;
	emutimer=0;
	resetperiph();
	return 0;
}

int stopemu()
{
	emustate=0;
	return 0;
}

int setnormalspeed()
{
	maxspeed=0;
	mytickcount=GetTickCount();
	return 0;
}

int setmaxspeed()
{
	maxspeed=1;
	mytickcount=GetTickCount();
	return 0;
}

int ismaxspeed()
{
	return maxspeed;
}

int shouldwait()
{
	int g;

	if (ismaxspeed()) return 0;

	g=GetTickCount();
	if (g-mytickcount<1000/EFREQ) return 1;
	mytickcount+=1000/EFREQ;
	if (g-mytickcount>1000) mytickcount=g;
	return 0;
}

int runemu()
{
	int     i,j,nbinstr;
	
	if (!isemurunning()) return 0;

	nbinstr=330000/EFREQ/3;

	for(j=0;j<3;j++)
	{
		for(i=0;i<nbinstr;i++) exe6809();
//		TOrepaint();
	}
		TOrepaint();

	emutimer+=10;
	if (emutimer>=EFREQ)
	{
		emutimer-=EFREQ;
		if (!(ccrest&0x10))
		{
			ccrest|=0x80;
			pshsr(0xff);
			ccrest|=0x10;
			pc=((buf[0xfff8]<<8)+(buf[0xfff9]&255))&0xffff;
		}
	}

	return 0;
}

void initemu()
{
	
#ifdef TO770
	endmem=0xdfff;
#else
	endmem=0xbfff;
#endif
	
	ini6809();
	iniperiph();
	importrom();
	resetpia();
}


